--- packet-ieee80211.c.orig	2004-07-18 19:07:17.906250000 +0200
+++ packet-ieee80211.c	2004-07-18 19:12:54.031250000 +0200
@@ -2317,8 +2317,12 @@
 				    "WEP ICV: 0x%08x (not verified)", 
 				    tvb_get_ntohl(tvb, hdr_len + ivlen + len));
 
-      call_dissector(data_handle, next_tvb, pinfo, tree);
-      return;
+      if (pinfo->ethertype != ETHERTYPE_CENTRINO_PROMISC)
+      {
+        /* Some wireless drivers (such as Centrino) WEP payload already decrypted */
+        call_dissector(data_handle, next_tvb, pinfo, tree);
+        return;
+      }
     } else {
 
       if (tree)
@@ -3231,6 +3235,7 @@
 						   proto_wlan);
   dissector_add("wtap_encap", WTAP_ENCAP_IEEE_802_11_WITH_RADIO,
 		ieee80211_radio_handle);
+  dissector_add("ethertype", ETHERTYPE_CENTRINO_PROMISC, ieee80211_handle);
 }
 
 static tvbuff_t *try_decrypt_wep(tvbuff_t *tvb, guint32 offset, guint32 len) {
